%This file calculates the JADE objective function landscape.
%Neil Gadhok, v1.0, November 26, 2004.
function [phi] = JADE_Cntrst(x,W);
%We want to minimize the off diagonal components (minimize the contrast function).

%The JADE (Joint Approximate Diagonalization of Eigenmatrices) algorithm
%is an ICA that achieves indepdence by minimizing the sum of squares
%of the off diagonal components of the cross-cumulants. It is an orthongal
%algorithm as it whitens (and normalizes) the data and then searches for a rotation that 
%minimizes the contrast function.
%[Card99] J.F. Cardoso, "Higher-order Contrasts for Independent Component Analysis", Neural Computation, vol. 11, pp. 157-192, 1999.

[m,n] = size(x);
        
 y = W*x;
 phi = 0;     

        %Solve Eq 3.11 {Card99]
         for i = 1:m,
            for j= m:-1:1,
                if ~(i == j),
                    for k = 1:m,
                        for l = 1:m,
                        
                            phi = phi + (cumulant(y(i,:),y(j,:),y(k,:),y(l,:)))^2;
                        
                        end
                    end
                end
            end
        end
        
                
