%This calculates the Vasicek m-spacings entropy.
%Neil Gadhok, v1.0, November 30, 2004.
function H = Radical_Vasicek(x)

N = length(x);

x = x - mean(x);
x = x / sqrt(var(x));

z = sort(x);
mN = floor(sqrt(N));

H = 0;
for i = 1:N-mN,
    H = H + log( ((N+1)/mN) * (z(i+mN) - z(i)) );
end
H = (1/(N-mN)) * H;
